package gov.nist.NLSAMLPlugin;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import net.sf.ehcache.Cache;
import net.sf.ehcache.CacheException;
import net.sf.ehcache.CacheManager;
import net.sf.ehcache.Element;


import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.bluejungle.framework.expressions.EvalValue;
import com.bluejungle.framework.expressions.IEvalValue;
import com.bluejungle.framework.expressions.ValueType;
import com.bluejungle.pf.domain.destiny.serviceprovider.ISubjectAttributeProvider;
import com.bluejungle.pf.domain.destiny.serviceprovider.ServiceProviderException;
import com.bluejungle.pf.domain.destiny.subject.IDSubject;

//import org.

public class UserAttrProviderMod implements ISubjectAttributeProvider {

	 private static final Log LOG = LogFactory.getLog(UserAttrProviderMod.class);

		private IEvalValue finalValue=null;
		private HTTPSTransmitter soapTransmitter;
		private String attributeValue;
		private Cache nlCache;
		//static StandaloneCache<CacheKey, String> cache; 
		//Create a CacheManager using defaults
		static CacheManager manager ;
		//Create a Cache specifying its configuration.
		
		
		//manager.addCache(nlCache);
		
		 	// @Override
		
		
		public void init() throws Exception {
			finalValue = IEvalValue.NULL;
			attributeValue = "";
			manager = CacheManager.create();
			soapTransmitter = new HTTPSTransmitter();
			 nlCache = new Cache("nlCache", 10000, true, false, 60, 30, false, 0);
			manager.addCache(nlCache);
			//cache=new EhcacheManager().getStandaloneCache();
			LOG.info("PDPPlugin UserAttrProviderMod init() called.");
			LOG.error("PDPPlugin UserAttrProviderMod init() called.");
			LOG.fatal("PDPPlugin UserAttrProviderMod init() called.");
		}

		

		/**
		 * Method to dynamically fetch attribute from any source. (-NL)
		 */
		//@Override
		public IEvalValue getAttribute(IDSubject arg0, String arg1) throws ServiceProviderException 
				{
			// arg0 represents user id
			// arg1 represents attribute that is missing
			LOG.info("PDPPlugin UserAttrProviderMod getAttribute() function called.");
			LOG.error("PDPPlugin UserAttrProviderMod getAttribute() function called.");
			LOG.fatal("PDPPlugin UserAttrProviderMod getAttribute() function called.");
			
			String subjectId = arg0.toString();
			String attributeName = arg1;
			//cache.put(subjectId, attributeName);
	         CacheKey cacheKey=new CacheKey(subjectId, attributeName);
			/**
			 * Call methods in CacheEngine class to check custom local cache first.
			 */
	         LOG.info("Trying to check if there exist a prior entry in cache.");
			boolean isAlreadyStored;
			try {
				isAlreadyStored = ( nlCache.get(cacheKey)!=null);
			
			if (isAlreadyStored) {
				LOG.info(" Prior entry Exists in cache.");
				attributeValue = (String) nlCache.get(cacheKey).getValue();
				EvalValue evalValue=new EvalValue(ValueType.STRING, attributeValue);
				finalValue = evalValue;
				return finalValue;
			}
	       
			/**
			 * If attribute's value is not found in cache, create
			 * soapHTTPTransmitter object and call its transmit() function.
			 * 
			 * If attribute's value is returned, put in cache, build EvalValue and
			 * return as EvalValue.
			 */
			else {
				
				
					
                    LOG.info("Using soapHTTPTransmitter object and calling its transmit() function.");
					Map<String,List<String>> attributes;
	                attributes = soapTransmitter.doPost( subjectId, attributeName); // How to get requester from Metadata from PF

	                Iterator<List<String>> attributeIterator = attributes.values().iterator();
	                while (attributeIterator.hasNext()) {
	                      attributeValue = attributeIterator.next().get(0);
	                      nlCache.put((new Element(new CacheKey(subjectId,attributeName), attributeValue)));
	                     // cacheEngine.storeValue(key, attributeValue);                                 
	                }

	                // Builds EvalValue to be returned
	                finalValue = new EvalValue(ValueType.STRING, attributeValue);
	                return finalValue;
				
			}

			
		
				} catch (IllegalStateException e1) {
					LOG.info("Exception while transmitting or getting response back",e1);
					e1.printStackTrace();
				} catch (CacheException e1) {LOG.info("Exception while transmitting or getting response back",e1);// TODO Auto-generated catch block
					e1.printStackTrace();
				}	catch (Exception e) {
					LOG.info("Exception while transmitting or getting response back",e);
				} 
			return null;
				}
		
}
