package nist.pdpplugin.crypto;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.Socket;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.Principal;
import java.security.PrivateKey;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;

import javax.net.ssl.X509KeyManager;

public class TLSKeyManager implements X509KeyManager {
    private AbacKeyManager abacKeyManager;
	public TLSKeyManager(String keyStoreFilename,
            String keyStorePassword, String keyPassword) throws UnrecoverableKeyException, KeyStoreException, NoSuchAlgorithmException, CertificateException, FileNotFoundException, IOException {
		abacKeyManager=new AbacKeyManager(keyStoreFilename,
             keyStorePassword,  keyPassword);
	}

	@Override
	public String chooseClientAlias(String[] arg0, Principal[] arg1, Socket arg2) {
		System.out.println("TLSKeyManager::chooseClientAlias");
		String aliase=this.getAbacKeyManager().getAlias();
		return aliase;
	}

	@Override
	public String chooseServerAlias(String arg0, Principal[] arg1, Socket arg2) {
		System.out.println("TLSKeyManager::chooseServerAlias");
		return null;
	}

	@Override
	public X509Certificate[] getCertificateChain(String arg0) {
		return new X509Certificate[] {this.getAbacKeyManager().getX509Certificate()};
	}

	@Override
	public String[] getClientAliases(String arg0, Principal[] arg1) {
		String aliase=this.getAbacKeyManager().getAlias();
		System.out.println("Alias returned="+aliase);
		return new String[] {aliase};
	}

	@Override
	public PrivateKey getPrivateKey(String arg0) {
		return this.getAbacKeyManager().getPrivateKey();
	}

	/**
	 * @return the abacKeyManager
	 */
	public AbacKeyManager getAbacKeyManager() {
		return abacKeyManager;
	}

	/**
	 * @param abacKeyManager the abacKeyManager to set
	 */
	public void setAbacKeyManager(AbacKeyManager abacKeyManager) {
		this.abacKeyManager = abacKeyManager;
	}

	@Override
	public String[] getServerAliases(String arg0, Principal[] arg1) {
		// TODO Auto-generated method stub
		return null;
	}

}
