package nist.pdpplugin.saml;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import nist.pdpplugin.saml.metadata.IDPMetadataReader;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.opensaml.saml2.core.Attribute;
import org.opensaml.saml2.core.Response;
import org.opensaml.ws.soap.soap11.Body;
import org.opensaml.ws.soap.soap11.Envelope;
import org.opensaml.xml.XMLObject;
import org.opensaml.xml.parse.BasicParserPool;
import org.opensaml.xml.util.XMLHelper;



public class SoapSAML2 extends SAMLInitializer{
	BasicParserPool parserPool = null;
	static Logger log = LogManager.getLogger(SoapSAML2.class);
	public SoapSAML2() {
		super();
		parserPool = new BasicParserPool();
		parserPool.setNamespaceAware(true);
		
	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub

	}
	public  Envelope buildSOAP11Envelope(XMLObject payload) {
        super.getInstance();
        if(getBuilderFactory()==null) System.out.println("Buildfactory is null");
        System.out.println("Buildfactory is initialized="+super.isInitialized());
        Envelope envelope = (Envelope) getBuilderFactory().getBuilder(Envelope.DEFAULT_ELEMENT_NAME).buildObject(Envelope.DEFAULT_ELEMENT_NAME);
        Body body = (Body) getBuilderFactory().getBuilder(Body.DEFAULT_ELEMENT_NAME).buildObject(Body.DEFAULT_ELEMENT_NAME);
         
        body.getUnknownXMLObjects().add(payload);
        envelope.setBody(body);
         
        return envelope;
    }
	public Response parseEnvelope(Envelope envelope){
		 List<XMLObject> response =envelope.getBody().getUnknownXMLObjects();
		    log.debug("SOAP Response was:");
		    log.debug(XMLHelper.prettyPrintXML(envelope.getDOM()));
		    //There should only ever be one Response element so:
		    
		    for(XMLObject resp :  response){
		      if (resp instanceof Response){
		        
		        return (Response) resp;
		      }
		      log.debug("Found something other than response: ");
		      log.debug(XMLHelper.prettyPrintXML(resp.getDOM()));
		    }
		    return null;
	}

	public Map<String, List<String>> getAttributes(Envelope envelope){
		Map<String,List<String>> valueMap=new HashMap<String,List<String>>();
		Response response= this.parseEnvelope(envelope);
		List<Attribute> attributes=response.getAssertions().get(0).getAttributeStatements().get(0).getAttributes();
		for (Attribute attr:attributes ){
			ListIterator<XMLObject> values=attr.getAttributeValues().listIterator();
			
			//List<XMLObject> data=attr.getAttributeValues();
			
			String key=attr.getName();
			List<String> valueList=new ArrayList<String>();
			while(values.hasNext()){
				String value=values.next().toString();
				valueList.add(value);
			}
			valueMap.put(key,valueList);
		}
		return valueMap;
	}
	/**
	 * @return the parserPool
	 */
	public BasicParserPool getParserPool() {
		return parserPool;
	}

	/**
	 * @param parserPool the parserPool to set
	 */
	public void setParserPool(BasicParserPool parserPool) {
		this.parserPool = parserPool;
	}
}
