package nist.pdpplugin.saml.metadata;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.opensaml.saml2.metadata.provider.AbstractMetadataProvider;
import org.opensaml.saml2.metadata.provider.MetadataProviderException;
import org.opensaml.xml.ConfigurationException;
import org.opensaml.xml.XMLObject;
import org.opensaml.xml.io.UnmarshallingException;
import org.opensaml.xml.parse.BasicParserPool;
import org.opensaml.xml.parse.ParserPool;

public class SPMetadataReader extends AbstractMetadataProvider{

	ByteArrayInputStream metadata=null;
	private ParserPool parser;
	static Logger log = LogManager.getLogger(SPMetadataReader.class);
	FileInputStream fis = null;
	String metaDataLocation=null;
	public String getMetaDataLocation() {
		return metaDataLocation;
	}


	public void setMetaDataLocation(String metaDataLocation) {
		this.metaDataLocation = metaDataLocation;
	}


	public SPMetadataReader(String metaDataLoc) throws IOException{
		// A Db call to get meta data. Currently trying to read using FIle
        parser=new BasicParserPool();
        super.setParserPool(parser);
        this.setMetaDataLocation(metaDataLoc);



	}


	public XMLObject getMetadata() throws MetadataProviderException {
		XMLObject cachedMetadata=null;
		try {
			 fis= new FileInputStream(new File(this.getMetaDataLocation()));                //(FileInputStream) this.getClass().getResourceAsStream(this.getMetaDataLocation());
	         int n=fis.available();
	         System.out.println("Available Bytes="+n);
	         log.error("Available Bytes="+n);
	         cachedMetadata = unmarshallMetadata(fis);
	         return cachedMetadata;
            }


		 catch (UnmarshallingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			throw new MetadataProviderException(e);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
	    	if(fis!=null)
				try {
					fis.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		      }
		return null;
	}
   public static void main(String[] args){
	   try {
		   org.opensaml.DefaultBootstrap.bootstrap();
		   SPMetadataReader deceMetaDataProvider=new SPMetadataReader("C:\\dev\\Metadata2.xml");
		XMLObject xmlObject=deceMetaDataProvider.getMetadata();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (MetadataProviderException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (ConfigurationException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
   }


@Override
protected XMLObject doGetMetadata() throws MetadataProviderException {
	// TODO Auto-generated method stub
	return null;
}

}
